clang-tools 8.0.0

Public Attributes | Static Public Attributes | List of all members
clang::clangd::CodeAction Struct Reference

A code action represents a change that can be performed in code, e.g. More...

`#include <Protocol.h>`

Collaboration diagram for clang::clangd::CodeAction:
[legend]

## Public Attributes
std::string | title
| A short, human-readable, title for this code action. More...
llvm::Optional< std::string > | kind
| The kind of the code action. More...
llvm::Optional< std::vector< Diagnostic > > | diagnostics
| The diagnostics that this code action resolves. More...
llvm::Optional< WorkspaceEdit > | edit
| The workspace edit this code action performs. More...
llvm::Optional< Command > | command
| A command this code action executes. More...

## Static Public Attributes
static const llvm::StringLiteral | QUICKFIX_KIND = "quickfix"

## Detailed Description

A code action represents a change that can be performed in code, e.g.

to fix a problem or to refactor code.

A CodeAction must set either `edit` and/or a `command`. If both are supplied, the `edit` is applied first, then the `command` is executed.

Definition at line 665 of file Protocol.h.

## Member Data Documentation

## ◆ command

llvm::Optional<Command> clang::clangd::CodeAction::command

A command this code action executes.

If a code action provides an edit and a command, first the edit is executed and then the command.

Definition at line 682 of file Protocol.h.

Referenced by clang::clangd::asCommand(), and clang::clangd::toJSON().

## ◆ diagnostics

llvm::Optional<std::vector<Diagnostic> > clang::clangd::CodeAction::diagnostics

The diagnostics that this code action resolves.

Definition at line 675 of file Protocol.h.

Referenced by clang::clangd::toJSON().

## ◆ edit

llvm::Optional<WorkspaceEdit> clang::clangd::CodeAction::edit

The workspace edit this code action performs.

Definition at line 678 of file Protocol.h.

Referenced by clang::clangd::asCommand(), clang::clangd::toCodeAction(), and clang::clangd::toJSON().

## ◆ kind

llvm::Optional<std::string> clang::clangd::CodeAction::kind

The kind of the code action.

Used to filter code actions.

Definition at line 671 of file Protocol.h.

Referenced by clang::clangd::asCommand(), clang::clangd::toCodeAction(), and clang::clangd::toJSON().

## ◆ QUICKFIX_KIND

const llvm::StringLiteral clang::clangd::CodeAction::QUICKFIX_KIND = "quickfix"
| static

Definition at line 672 of file Protocol.h.

Referenced by clang::clangd::asCommand(), clang::clangd::toCodeAction(), and clang::clangd::toJSON().

## ◆ title

std::string clang::clangd::CodeAction::title

A short, human-readable, title for this code action.

Definition at line 667 of file Protocol.h.

Referenced by clang::clangd::asCommand(), clang::clangd::toCodeAction(), and clang::clangd::toJSON().

The documentation for this struct was generated from the following files:

- Protocol.h
- Protocol.cpp